﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
namespace SIMSInterface
{
    public class MappingTable
    {
        
        private static Dictionary<Guid,int> reverseMappings = new Dictionary<Guid,int>();
        private static Dictionary<int, Guid> mappings = new Dictionary<int,Guid>();
        public MappingTable()
        {
            if (mappings.Count == 0)
            {
                SIMS.Processes.TPSIFSupport tpss = new SIMS.Processes.TPSIFSupport();
                XmlDocument map =  tpss.GetSifRefIdsAsXML();
                foreach (XmlNode n in map.SelectNodes("People/Person"))
                {
                    string x = n["ExternalID"].InnerXml;
                    string i = n["PersonID"].InnerXml;
                    mappings.Add(int.Parse(i), Guid.Parse(x));
                    reverseMappings.Add(Guid.Parse(x), int.Parse(i));
                }
            }
        }
        public Guid GetExternalId(int internalID)
        {

            Guid g = Guid.Empty;
            mappings.TryGetValue(internalID, out g);
            return g;
        }
        public int GetInternalID(Guid externalID)
        {
            int i = 0;
            reverseMappings.TryGetValue(externalID, out i);
            return i;
        }

    }
}
